// generictimer.cpp
// M. Schukat, 2002

// Include header files

#include <iostream.h>

#include "GenericTimer.h"


// 1. modification (definition of constructor)
// Implementation of Constructor GenericTimer::GenericTimer
// Remark: NOT void GenericTimer:: ..., since this is a constructor
GenericTimer::GenericTimer(void)
{
	minutes = 0;
	seconds = 0;
}
// 


// 2. modification (definition of second constructor to show function overloading)
// Implementation of Constructor GenericTimer::GenericTimer(int s, int m)
// Remark: NOT void GenericTimer:: ..., since this is a constructor
GenericTimer::GenericTimer(int s, int m)
{
	// Init object with values s and m.
	minutes = m;
	seconds = s;
}
//


// 3. modification (definition of function to show default argument list of function)
// Implementation of method GenericTimer::IncrementTimer(int s = 1, int m = 0) 
// Standard arguments are not part of the declaration!
void GenericTimer::IncrementTimer(int s, int m)
{
	// The timer will be incremented properly by any amout of time.
	minutes += m;
	seconds += s;
	minutes += (s / 60);
	seconds %= 60;
	minutes %= MaxMinutes;
}
//


// Implementation of method GenericTimer::Reset
void GenericTimer::Reset(void)
{
	minutes = 0;
	seconds = 0;
}


// Implementation of method GenericTimer::Tick
void GenericTimer::Tick(void)
{
	seconds++;
	if (seconds >= 60)
	{
		seconds = 0;
		minutes++;
		
		// 4. modification: Replace "34" with const variable MaxMinutes
		if (minutes > MaxMinutes)
		//
		{
			minutes = 0;
		}
	}
}


// Implementation of method GenericTimer::PrintTime
void GenericTimer::PrintTime(void)
{
	cout << endl << "Current Time = " << (seconds + minutes * 60) << endl;
}



