// animal2.cpp
// This program is base on animal1. void favoriteFood(void) is a virtual function
// and animal is a virtual class. You cannot create instances of animal, but you can
// create pointers to animal.
// M. Schukat, 2002

// Header files
#include <string.h>
#include <stdlib.h>
#include <iostream.h>


// Class definition for animal
class animal
{
protected:
	// Pointer to a name
	char* name;

public:
	// Constructor
	animal(char* s)
	{
		name = new char[strlen(s) + 1];
		strcpy (name, s);
	}

	// Destructor
	~animal(void)
	{
		delete [] name;
	}

	// Function void favoriteFood(void)
	// ... = 0 indicates, that this is a virtual class
	virtual void favoriteFood(void) = 0;
};


// Class definition for pig
class pig : public animal
{
public:
	// Constructor: we call the constructor of the superclass.
	pig(char* s) : animal(s) {}

	// Function favoriteFood()
	void favoriteFood(void) {cout << "Favorite food of " << name <<": Apples." << endl;}
};


// Class definition for cow
class cow : public animal
{
public:
	// Constructor: we call the constructor of the superclass.
	cow(char* s) : animal(s) {}

	void favoriteFood(void) {cout << "Favorite food of " << name << ": Hay." << endl;}
};


// Main function

int main(void)
{
	// In order to keep deal with a set of pigs and cows, we define an array of pointers of the
	// base class animal. The individual pointers will point to cow and pig objects.
	animal* myAnimal[3];

	// Remark: Since animal is a virtual class nnow, we cannot do an definition like <animal a1;>;

	// We can do this assignment, because cow and pig are subclasses of animal. It is implicite
	// casting.
	myAnimal[0] = new cow("Cow1");
	myAnimal[1] = new cow("Cow2");
	myAnimal[2] = new pig("Pig1");

	// Use polymorphism to call the appropriate function for pigs and cows.
	myAnimal[0]->favoriteFood();
	myAnimal[1]->favoriteFood();
	myAnimal[2]->favoriteFood();

	return 0;
}