// friend2.cpp
// Implementation of a friend member function
// M. Schukat, 2002


// Include header files
#include <iostream.h>
#include <stdlib.h>


// Forward reference to class RandomGenerator:
// The parser needs to know that there is a class
// RandomGenerator, where we refer to in DebugProgram
class RandomGenerator;


// Class definition of DebugProgram
class DebugProgram
{
private:
	int errorcounter;

public:
	// Constructor
	DebugProgram(void) : errorcounter(0) {}

	// Function CheckData
	void CheckData(RandomGenerator t);

	// Function PrintCounter
	void PrintCounter(void)
	{
		cout << "PrintCounter: errorcounter = " << errorcounter << endl;
	}
};


// Class definition of RandomGenerator
class RandomGenerator
{
private:
	int v1, v2;

public:
	RandomGenerator(void) : v1(0), v2(0) {}

	// Function GetRandom
	int GetRandom(void)
	{
		v1 = rand();
		v2 = rand();

		return v1 - v2;
	}

	// Friend function
	// Important:We need to pass a reference to the object.
	friend void DebugProgram::CheckData(RandomGenerator t);
};


// Implementation of void DebugProgram::CheckData(RandomGenerator t)

void DebugProgram::CheckData(RandomGenerator t)
{
	if (t.v1 == t.v2)
	{
		errorcounter++;
	}
}


// Main function
int main(void)
{
	RandomGenerator t1;
	DebugProgram db;

	cout << "The random value is " << t1.GetRandom() << endl;

	// Call of friend function
	// Important:We need to pass a reference to the object in question
	db.CheckData(t1);

	// ... 

	// Print result of debug session
	db.PrintCounter();

	return 0;
}

