// friend3.cpp
// Implementation of a friend class
// M. Schukat, 2002


// Include header files
#include <iostream.h>
#include <stdlib.h>


// Forward reference to class RandomGenerator:
// The parser needs to know that there is a class called
// RandomGenerator, since we refer to it in class DebugProgram
class RandomGenerator;


// Class definition of DebugProgram
class DebugProgram
{
private:
	int errorcounter;

public:
	// Constructor
	DebugProgram(void) : errorcounter(0) {}

	// function CheckData
	void CheckData(RandomGenerator t);

	// Function PrintCounter
	void PrintCounter(void)
	{
		cout << "PrintCounter: errorcounter = " << errorcounter << endl;
	}
};


// Class definition of RandomGenerator
class RandomGenerator
{
private:
	int v1, v2;

public:
	RandomGenerator(void) : v1(0), v2(0) {}

	// Function GetRandom
	int GetRandom(void)
	{
		v1 = rand();
		v2 = rand();

		return v1 - v2;
	}

	// Friend class defintion:
	// Every member function and every instance of DebugProgram has 
	// total access to every instance of RandomGenerator.
	friend class DebugProgram;
};


// Implementation of void DebugProgram::CheckData(RandomGenerator t)
void DebugProgram::CheckData(RandomGenerator t)
{
	if (t.v1 == t.v2)
	{
		errorcounter++;
	}
}


// Main function
int main(void)
{
	RandomGenerator t1;
	DebugProgram db;

	cout << "The random value is " << t1.GetRandom() << endl;

	// Here we take advantage of friend definition.
	db.CheckData(t1);

	// ...

	// Print result of debug session
	db.PrintCounter();

	return 0;
}

