// List_static.cpp: List implementation with const attribute
// M. Schukat, 2002
 
// Include header files
#include <iostream.h>
#include <stdlib.h>
#include <math.h>

#include "list_const.h"


// Implementation of bool DoubSet::IsElement(double x)
bool DoubSet::IsElement(double x)
{
	// return if list is empty.
	if (Empty())
	{
		return false;
	}
	else
	{
		DoubElem* tmp = start;

		// Go through list until element is found or list is ended.
		do
		{
			if (fabs(tmp->element - x) < eps * fabs(x))
			{
				return true;
			}
			else
			{
				tmp = tmp->next;
			}
		} while (tmp != 0);
	}
	return false;
}


// Implementation of bool DoubSet::Insert(double x)
bool DoubSet::Insert(double x)
{
	// Don't add similar elements twice.
	if (IsElement(x))
	{
		return false;
	}
	else
	{
		// Create new element and link it to list.
		DoubElem* tmp = new DoubElem;
		tmp->element = x;
		tmp->next = start;

		start = tmp;

		number++;

		return true;
	}
}


// Implementation of bool DoubSet::Content(void)
void DoubSet::Content(void)
{
	// Print content of list.
	cout << "{ ";

	if (!Empty())
	{
		DoubElem* tmp = start;

		cout << tmp->element;
		
		while (tmp->next != 0)
		{
			tmp = tmp->next;
			cout << ", " << tmp->element;
		}
	}
	cout << " }" << endl;
}

// Declaration of destructor.
DoubSet::~DoubSet(void)
{
	if (Empty())
	{
		return;
	}
	else
	{
		while (start != 0)
		{
			DoubElem* tmp = start;
			start = start->next;
			delete tmp;
		}
	}
}
