// List_s.cpp
// Example code for shallow copy
// New function; void DoubSet::IncrementAllElements(void)
// M. Schukat, 2002
 

// Include header files
#include <iostream.h>
#include <stdlib.h>
#include <math.h>

#include "list_s.h"


// Implementation of bool DoubSet::IsElement(double x) - old stuff
bool DoubSet::IsElement(double x) const 
{
	// return if list is empty.
	if (Empty())
	{
		return false;
	}
	else
	{
		DoubElem* tmp = start;

		// Go through list until element is found or list is ended.
		do
		{
			if (fabs(tmp->element - x) < 1.0E-15 * fabs(x))
			{
				return true;
			}
			else
			{
				tmp = tmp->next;
			}
		} while (tmp != 0);
	}
	return false;
}


// Implementation of bool DoubSet::Insert(double x) - old stuff
bool DoubSet::Insert(double x)
{
	// Don't add similar elements twice.
	if (IsElement(x))
	{
		return false;
	}
	else
	{
		// Create new element and link it to list.
		DoubElem* tmp = new DoubElem;
		tmp->element = x;
		tmp->next = start;

		start = tmp;

		number++;

		return true;
	}
}


// Implementation of bool DoubSet::Content(void) - old stuff
void DoubSet::Content(void) const
{
	// Print content of list.
	cout << "{ ";

	if (!Empty())
	{
		DoubElem* tmp = start;

		cout << tmp->element;
		
		while (tmp->next != 0)
		{
			tmp = tmp->next;
			cout << ", " << tmp->element;
		}
	}
	cout << " }" << endl;
}


// The destructor
DoubSet::~DoubSet(void)
{
	if (Empty())
	{
		return;
	}
	else
	{
		while (start != 0)
		{
			DoubElem* tmp = start;
			start = start->next;
			delete tmp;
		}
	}
}


// Implementation of void DoubSet::IncrementAllElements(void) - New function
// All elemets of set are incremented by one.
void DoubSet::IncrementAllElements(void)
{
	// return if list is empty.
	if (!Empty())
	{
		DoubElem* tmp = start;

		// Go through list until element is found or list is ended.
		do
		{
			// Inrecement element by one.
			tmp->element++;

			// Go to next pointer
			tmp = tmp->next;
		} while (tmp != 0);
	}
}